Subject: Re: bug#18121: A bug in sort.

From: Paul Eggert <[email-masked]>
Date: Mon, 28 Jul 2014 11:50:14 -0400

On 07/28/2014 04:41 AM, Pádraig Brady wrote:
> This case might be indicative of single bit errors in RAM,
> as the difference between '|' and 'x' is only a single bit.
> I would first eliminate that possibility with a RAM checker.

Good diagnosis, thanks.  I use ECC RAM in machines I do nontrivial work 
on, so attempting to work around this is low priority for me, but 
someone with some free time on their hands might look into having 'sort' 
detect internal memory corruption via permutation-insensitive 
checksums.  This wouldn't catch all hardware errors, but it might help 
folks who are trying to push too much data through systems with 
unreliable memory.

For some eye-opening analysis on how unreliable non-ECC RAM can be, see:

http://www.pugetsystems.com/labs/articles/Advantages-of-ECC-Memory-520/